Index: apps/app_voicemail2.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_voicemail2.c,v
retrieving revision 1.56
diff -u -r1.56 app_voicemail2.c
--- apps/app_voicemail2.c	4 Oct 2003 22:08:02 -0000	1.56
+++ apps/app_voicemail2.c	14 Oct 2003 05:16:56 -0000
@@ -691,27 +712,26 @@
 			struct ast_channel *ast = ast_channel_alloc(0);
 			if (ast) {
 				char *passdata;
-				int vmlen = strlen(emailbody)*2;
-				if (vmlen < 20)
-					vmlen = 100;
-				passdata = alloca(vmlen);
-				bzero( passdata, vmlen );
-				pbx_builtin_setvar_helper(ast, "VM_NAME", name);
-				pbx_builtin_setvar_helper(ast, "VM_DUR", dur);
-				sprintf(passdata,"%d",msgnum);
-				pbx_builtin_setvar_helper(ast, "VM_MSGNUM", passdata);
-				pbx_builtin_setvar_helper(ast, "VM_MAILBOX", mailbox);
-				pbx_builtin_setvar_helper(ast, "VM_CALLERID", (callerid ? callerid : "an unknown caller"));
-				pbx_builtin_setvar_helper(ast, "VM_DATE", date);
-				pbx_substitute_variables_helper(ast,emailbody,passdata,vmlen);
-				fprintf(p, "%s\n",passdata);
+				int vmlen = strlen(emailbody)*3 + 200;
+				if ((passdata = alloca(vmlen))) {
+					memset(passdata, 0, vmlen);
+					pbx_builtin_setvar_helper(ast, "VM_NAME", name);
+					pbx_builtin_setvar_helper(ast, "VM_DUR", dur);
+					sprintf(passdata,"%d",msgnum);
+					pbx_builtin_setvar_helper(ast, "VM_MSGNUM", passdata);
+					pbx_builtin_setvar_helper(ast, "VM_MAILBOX", mailbox);
+					pbx_builtin_setvar_helper(ast, "VM_CALLERID", (callerid ? callerid : "an unknown caller"));
+					pbx_builtin_setvar_helper(ast, "VM_DATE", date);
+					pbx_substitute_variables_helper(ast,emailbody,passdata,vmlen);
+					fprintf(p, "%s\n",passdata);
+				} else ast_log(LOG_WARNING, "Cannot allocate workspace for variable substitution\n");
 				ast_channel_free(ast);
 			} else ast_log(LOG_WARNING, "Cannot allocate the channel for variables substitution\n");
 		} else {
